{% extends 'base.html.twig' %}
{% form_theme form 'bootstrap_4_layout.html.twig' %}

{% block stylesheets %}
    <style>
        .characteristics {
            list-style: none;
        }
    </style>
{% endblock %}
{% block body %}
    <div class="row">
        <h2 class="col text-center">{{ title }}</h2>
    </div>
    <div class="row py-2" id="btn-action-fixed">
        <div class="col text-center">
            <button type="button" class="btn btn-secondary btn-sm"
                    onclick="$('#{{ form.save.vars.id }}').click();return false;">Сохранить
            </button>
            <a href="{{ path('product_index') }}" role="link" class="btn btn-secondary btn-sm">Закрыть</a>
        </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-12 col-md-10 col-lg-8 col-xl-6">
            {{ form_start(form) }}
            {{ form_row(form.name) }}
            {{ form_row(form.category) }}
            {{ form_row(form.price) }}
            <ul class="characteristics"
                data-prototype="{{ form_widget(form.characteristic.vars.prototype)|e('html_attr') }}">
                {% for char in form.characteristic %}
                    <li>
                        {{ form_errors(char.category) }}
                        {{ form_row(char.category) }}
                        {{ form_errors(char.value) }}
                        {{ form_row(char.value) }}
                    </li>
                {% endfor %}
            </ul>
            {{ form_end(form) }}
        </div>
    </div>

{% endblock %}
{% block javascripts %}
    <script>
        var $collectionHolder;

        // setup an "add a tag" link
        var $addTagButton = $('<button id="addChar" type="button" class="btn btn-secondary btn-sm mt-3">Добавить характеристику</button>');
        var $newLinkLi = $('<li></li>').append($addTagButton);


        // Get the ul that holds the collection of tags
        $collectionHolder = $('ul.characteristics');

        // add a delete link to all of the existing tag form li elements
        $collectionHolder.find('li').each(function() {
            addTagFormDeleteLink($(this));
        });

        // add the "add a tag" anchor and li to the tags ul
        $collectionHolder.append($newLinkLi);

        // count the current form inputs we have (e.g. 2), use that as the new
        // index when inserting a new item (e.g. 2)
        $collectionHolder.data('index', $collectionHolder.find('input').length);

        $(document).on('click', '#addChar', function (e) {
            // add a new tag form (see next code block)
            addTagForm($collectionHolder, $newLinkLi);
        });


        function addTagForm($collectionHolder, $newLinkLi) {
            // Get the data-prototype explained earlier
            var prototype = $collectionHolder.data('prototype');

            // get the new index
            var index = $collectionHolder.data('index');

            var newForm = prototype;
            // You need this only if you didn't set 'label' => false in your tags field in TaskType
            // Replace '__name__label__' in the prototype's HTML to
            // instead be a number based on how many items we have
            // newForm = newForm.replace(/__name__label__/g, index);

            // Replace '__name__' in the prototype's HTML to
            // instead be a number based on how many items we have
            newForm = newForm.replace(/__name__/g, index);

            // increase the index with one for the next item
            $collectionHolder.data('index', index + 1);

            // Display the form in the page in an li, before the "Add a tag" link li
            var $newFormLi = $('<li></li>').append(newForm);
            $newLinkLi.before($newFormLi);
            getCharacteristik(index);
            addTagFormDeleteLink($newFormLi);
        }

        function getCharacteristik(index) {
            var category = $('#product_category').val();
            var url = '/product/getchar/' + category;
            $.ajax({
                url: url,
                dataType: 'JSON',
                success: function (data) {
                    data.forEach(function (value) {
                        let option = '<option value="' + value['id'] + '">' + value['name'] + '</option>';
                        $('#product_characteristic_' + index + '_category').append(option);
                    });
                }
            });
        }

        function addTagFormDeleteLink($tagFormLi) {
            var $removeFormButton = $('<button type="button" class="btn btn-secondary btn-sm text-right">Удалить</button>');
            $tagFormLi.append($removeFormButton);

            $removeFormButton.on('click', function(e) {
                // remove the li for the tag form
                $tagFormLi.remove();
            });
        }

        $(document).on('change', '#product_category', function () {
            $collectionHolder.empty();
            $collectionHolder.append($newLinkLi);
        });
    </script>
{% endblock %}